import java.io.*;
import java.util.*;

public class C {
	class Event implements Comparable<Event> {
		long t;
		long st;
		int ind;

		public Event(int t, int st, int ind) {
			this.t = t;
			this.st = st;
			this.ind = ind;
		}

		@Override
		public int compareTo(Event x) {
			if (x.t < t) {
				return 1;
			}
			if (x.t > t) {
				return -1;
			}
			if (x.ind < ind) {
				return 1;
			}
			if (x.ind > ind) {
				return -1;
			}
			return 0;
		}
	}

	class El implements Comparable<El> {
		long l;
		long r;
		long maxSt;

		public El(long l, long r) {
			this.l = l;
			this.r = r;
			this.maxSt = (r - l) / 2 + 1;
		}

		@Override
		public int compareTo(El x) {
			 if (x.maxSt < maxSt) {
	                return -1;
	            }
	            if (x.maxSt > maxSt) {
	                return 1;
	            }
	            if (x.l < l) {
	                return -1;
	            }
	            if (x.l > l) {
	                return 1;
	            }
	            return 0;
		}
	}

	class El2 implements Comparable<El2> {
		long l;
		long r;

		public El2(long l, long r) {
			this.l = l;
			this.r = r;
		}

		@Override
		public int compareTo(El2 x) {
			if (x.l < l) {
				return -1;
			}
			if (x.l > l) {
				return 1;
			}
			return 0;
		}
	}

	public void solve() throws IOException {
		int n = nextInt();
		int m = nextInt();
		Event[] a = new Event[n];
		/*
		 * PriorityQueue <Event> q = new PriorityQueue(); for(int i = 0;i<n;i++) {
		 * q.add(new Event(nextInt(), nextInt(), i)); }
		 */
		TreeSet<El> b = new TreeSet();
		ArrayList<El2> ar = new ArrayList();
		long [] ans = new long[n];
		long last = 0;
	/*	b.add(new El(2, 3));
		b.add(new El(2, 4));
		b.add(new El(3, 4));
		b.add(new El(1, 2));*/
		for(int i = 0;i<n;i++) {
			a[i] = new Event(nextInt(), nextInt(), i);
		}
		Arrays.sort(a);
		for (int i = 0; i < n; i++) {
			Event w = a[i];
			int l = -1;
			int r = ar.size() - 1;
			/*while (r - l > 1) {
				int mid = (l + r) / 2;
				El2 now = ar.get(mid);
				if (w.t >= now.l) {
					r = mid;
				} else {
					l = mid;
				}
			}*/
			r = 0;
			for(r = 0;r<ar.size();r++) {
				if(w.t >= ar.get(r).l && w.t <= ar.get(r).r) {
					break;
				}
			}
			El2 now = new El2(0, 0);
			if(ar.size() != 0) {
				now = ar.get(r);
			}
		//	El2 now = ar.get(r);
			if (b.size() == 0 || now == null || w.st > (now.r - now.l) / 2 + 1
					|| w.t > now.r - w.st + 1) {
				El now2 = null;
				for(El x : b) {
					if(x.l > now.l && x.maxSt >= w.st) {
						now2 = x;
						break;
					}
				}
				if(now2 != null) {
					ans[w.ind] = now2.r;
				} else {
					last = Math.max(last, w.t);
					b.add(new El(last, last + 2 * (w.st - 1)));
					ar.add(new El2(last, last + 2 * (w.st - 1)));
					ans[w.ind] = last + 2 * (w.st - 1);
					last = ans[i];
				}
			} else {
				ans[w.ind] = now.r;
			}
		}
		for (int i = 0; i < n; i++) {
			out.println(ans[i]);
		}
	}

	public void run() {
		try {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new C().run();
	}

}
